=== debian/changelog ===
pytorch (2.5.1+dfsg-3) unstable; urgency=medium

  [ Stephen Kitt ]
  * Escape $ symbols in sed commands (Closes: #1088810)
  * debian/rules: avoid $(shell) where possible

  [ Mo Zhou ]
  * Autopkgtest: mark inline_container_test as flaky.
  * Refresh autopkgtest control file.
  * Add notes to d/rules for python3 support -- we only support one single
    python3 version, due to libtorch_python.so is built against a specific
    version and conflicts with other versions.
  * d/rules: Correct llvm-config version.
  * d/control: Add the missing B-D libzstd-dev.
  * Fix missing error trapping in Makefiles. (Closes: #1090052)
  * [trivial] rules: Replace spaces into tabs for consistent formatting.
  * rules: Only install necessary shared objects. (Closes: #1090053)

 -- Mo Zhou <lumin@debian.org>  Fri, 27 Dec 2024 00:36:00 -0500

pytorch (2.5.1+dfsg-2) unstable; urgency=medium

  * [CUDA] Build-Depends libcutlass-dev (>= 3.4.1+ds-2) to fix missing files.

 -- Mo Zhou <lumin@debian.org>  Sun, 24 Nov 2024 13:36:43 -0500

pytorch (2.5.1+dfsg-1) unstable; urgency=medium

  [ Shengqi Chen ]
  * New upstream version 2.5.1+dfsg
  * d/patches: add patch to remove dependency on python3-astunparse
    (closes: #1086773)

  [ Mo Zhou ]
  * Correction to the version.txt patch.

 -- Mo Zhou <lumin@debian.org>  Sat, 23 Nov 2024 13:30:36 -0500

pytorch (2.5.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.5.0:
    + Bump libtorch SOVERSION from 2.4 to 2.5.
    + d/rules: bump SOVERSION and PATCH.
    + d/kineto: update embeded source with commit
      d9753139d181b9ff42872465aac0e5d3018be415.
    + Remove embedded foxi which is not used anymore.
  * Packaging related:
    + d/copyright: remove superfluous excludes and comments.
    + d/control: bump minimal version of libdnnl in B-D.
    + d/control: add nlohmann-json3-dev in B-D.
    + d/control: use llvm-19 in B-D (incompatibility fixed by upstream).
    + d/control: remove dead or unsupported architectures.
      [CPU] now supports: amd64 arm64 ppc64el s390x riscv64
  * Patch related:
    + refresh all patches, remove useless ones.
    + update use-system-dnnl.patch to pass essential definition.
    + re-order in series file & refresh.
    + add patch to remove pkg_resources from tests.
  * Test related:
    + remove all tests from permissive list (not flaky now).
    + re-generate libtorch test stanza.

 -- Shengqi Chen <harry-chen@outlook.com>  Sat, 02 Nov 2024 13:30:22 +0800

pytorch (2.4.1-4) unstable; urgency=medium

  * Revert "Disable tensorpipe and remove it from Build-Depends,
    deprecated by upstream." There is a known python import error
    when disabling tensorpipe while enabling distributed backends.

 -- Mo Zhou <lumin@debian.org>  Thu, 24 Oct 2024 03:34:25 -0400

pytorch (2.4.1-3) unstable; urgency=medium

  [ Shengqi Chen ]
  * d/README.Source: update according to pytorch v2.5 release
  * d/control: bump std-ver to 4.7.0 (no changes required)
  * d/control: remove more useless Build-Depends
  * d/patches: remove already applied patch since 2.0.0
  * d/patches: update metadata & remove useless patch
  * d/patches: modify patch to also fix the version in built pip wheel
  * d/rules: remove duplicated dh_auto_clean target.
  * d/copyright: update according to current source

  [ Mo Zhou ]
  * Cleanup build options and B-Ds, and add more comments in d/rules.
    - [CPU] Enable MPI (mpi-default-dev) for CPU variant.
    - [all variants] Disable tensorpipe, deprecated and archived by upstream.
    - [all variants] remove B-D and corresponding build options on leveldb,
      lmdb, ffmpeg, opencv, zstd, etc. These dependencies are gone along
      with the upstream's deprecation of caffe2.
  * [CPU] Specify Build-Depends on llvm-18 to avoid FTBFS against llvm-19.
    (Closes: #1085004)
  * [CPU] Remove the rpath for openmpi shared object.
  * [CUDA] Install the missed libnnapi_backend.so
  * [ROCM] add initial attempt to enable ROCM build. (WIP)
  * Autopkgtest: update the blas test with cuda mode.
  * README.Source: update dependency tracker.

 -- Mo Zhou <lumin@debian.org>  Tue, 22 Oct 2024 23:58:27 -0400

pytorch (2.4.1-2) unstable; urgency=medium

  * [CPU] Remove LLVM from B-D for the CPU-only version.
  * [CUDA] Sync the latest control changes to control.cuda.
  * [CUDA] Specify B-D LLVM version as 18. It FTBFS with 19 (llvm-dev default).
  * [CUDA] Do not install the nvfuser shared object due to upstream removal.
  * [CUDA] Upload to unstable. (Closes: #1064484, #1053339, #1065943)

 -- Mo Zhou <lumin@debian.org>  Fri, 11 Oct 2024 00:05:38 -0400
